'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

require('./Button.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Button = function Button(_ref) {
    var _classNames;

    var htmlId = _ref.htmlId,
        name = _ref.name,
        type = _ref.type,
        size = _ref.size,
        classname = _ref.classname,
        onClick = _ref.onClick,
        children = _ref.children,
        props = _objectWithoutProperties(_ref, ['htmlId', 'name', 'type', 'size', 'classname', 'onClick', 'children']);

    var myClass = (0, _classnames2.default)('btn mg-button', (_classNames = {}, _defineProperty(_classNames, size, size), _defineProperty(_classNames, classname, classname), _classNames));

    return _react2.default.createElement(
        'button',
        Object.assign({
            className: myClass,
            id: htmlId,
            name: name,
            type: type,
            onClick: onClick
        }, props),
        children
    );
};

Button.defaultProps = {
    type: 'submit',
    children: 'Submit',
    size: '',
    classname: ''
};

Button.propTypes = {
    /** Unique HTML ID. Used for tying label to HTML input. Handy hook for automated testing. */
    htmlId: _propTypes2.default.string.isRequired,

    /** Input name. Recommend setting this to match object's property so a single change handler can be used. */
    name: _propTypes2.default.string.isRequired,

    /** Input type */
    type: _propTypes2.default.oneOf(['button', 'submit', 'reset']),

    /** Function to call onClick */
    onClick: _propTypes2.default.func.isRequired,

    /** Child component to display next to the input */
    children: _propTypes2.default.node,

    /** Size classname to use for different sizes */
    size: _propTypes2.default.string,

    /** Any additional classnames to add to it */
    classname: _propTypes2.default.string
};

exports.default = Button;