'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

require('./LikertScale.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var LikertScale = function LikertScale(props) {
    var valueIndex = props.options.indexOf(props.value.label[0]);
    var valueArr = new Array(props.options.length);

    var labelArrs = {
        size: ['Runs Small', 'True to Size', 'Runs Large'],
        width: ['Runs Narrow', 'True to Width', 'Runs Wide']
    };

    for (var i = 0; i < valueArr.length; i++) {
        if (i === 0) {
            valueArr[i] = 0;
        } else if (i === valueArr.length) {
            valueArr[i] = 100;
        } else {
            valueArr[i] = 100 / (valueArr.length - 1) * i;
        }
    }

    // Calculate the left position for the big black dot
    var dotStyle = {
        left: valueArr[valueIndex] - 2.5 + '%'
    };

    return _react2.default.createElement(
        'div',
        { className: 'likert-scale', style: { width: props.width } },
        _react2.default.createElement(
            'div',
            { className: 'label' },
            props.value.label
        ),
        _react2.default.createElement(
            'div',
            { className: 'dot-points' },
            valueArr.map(function (val, index) {
                var label = labelArrs[props.value.dimensionLabel.toLowerCase()];

                return _react2.default.createElement(
                    'div',
                    { key: index, className: 'small-dot', style: { left: val + '%' } },
                    [0, 2, 4].indexOf(index) !== -1 && _react2.default.createElement(
                        'span',
                        null,
                        label[[0, 2, 4].indexOf(index)]
                    )
                );
            })
        ),
        _react2.default.createElement('div', { className: 'dot', style: dotStyle }),
        _react2.default.createElement('div', { className: 'line', style: { width: props.width } })
    );
};

LikertScale.propTypes = {
    /** The value of the chart where the dot should display */
    value: _propTypes2.default.object.isRequired,

    /** The list of scale options for setting the values of the dot points */
    options: _propTypes2.default.array.isRequired,

    /** The list of scale options for setting the values of the dot points */
    width: _propTypes2.default.string
};

LikertScale.defaultProps = {
    width: '100%'
};

exports.default = LikertScale;