'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

require('./Pagination.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Pagination = function (_React$Component) {
    _inherits(Pagination, _React$Component);

    function Pagination(props) {
        _classCallCheck(this, Pagination);

        var _this = _possibleConstructorReturn(this, (Pagination.__proto__ || Object.getPrototypeOf(Pagination)).call(this, props));

        _this.setPage = function (page) {
            var items = _this.props.items;
            var pager = _this.state.pager;


            if (page < 1 || page > pager.totalPages) return;

            // Get new pager object for specified page
            pager = _this.getPager(items.length, page);

            // Get new page of items from items array
            var pageOfItems = items.slice(pager.startIndex, pager.endIndex + 1);

            _this.setState({
                pager: pager
            });

            _this.props.onChangePage(pageOfItems);
        };

        _this.getPager = function (totalItems) {
            var currentPage = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;

            var totalPages = Math.ceil(totalItems / _this.props.pageSize);
            var startPage = void 0,
                endPage = void 0;

            // TODO: Modify this so it works based on a prop numPagesToShow = 5
            if (totalPages <= 10) {
                // Show all if less than 10 pages
                startPage = 1;
                endPage = totalPages;
            } else {
                // Calculate start/end pages if more than 10
                /* eslint-disable no-lonely-if */
                if (currentPage <= 6) {
                    startPage = 1;
                    endPage = 10;
                } else if (currentPage + 4 >= totalPages) {
                    startPage = totalPages - 9;
                    endPage = totalPages;
                } else {
                    startPage = currentPage - 5;
                    endPage = currentPage + 4;
                }
                /* eslint-enable no-lonely-if */
            }

            // Calculate start and end item indexes
            var startIndex = (currentPage - 1) * _this.props.pageSize;
            var endIndex = Math.min(startIndex + _this.props.pageSize - 1, totalItems - 1);
            var pages = _lodash2.default.range(startPage, endPage + 1);

            return {
                pageSize: _this.props.pageSize,
                totalPages: totalPages,
                currentPage: currentPage,
                totalItems: totalItems,
                startPage: startPage,
                endPage: endPage,
                startIndex: startIndex,
                endIndex: endIndex,
                pages: pages
            };
        };

        _this.state = {
            pager: {}
        };
        return _this;
    }

    _createClass(Pagination, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            // Set page if items array isn't empty
            if (this.props.items && this.props.items.length) {
                this.setPage(this.props.initialPage);
            }
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate(prevProps) {
            // Reset page if items array has changed
            if (this.props.items !== prevProps.items) {
                this.setPage(this.props.initialPage);
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var pager = this.state.pager;

            // Don't show pagination if only 1 page

            if (!pager.pages || pager.pages.length <= 1) {
                return null;
            }

            return _react2.default.createElement(
                'ul',
                { className: 'pagination' },
                _react2.default.createElement(
                    'li',
                    { className: pager.currentPage === 1 ? 'disabled' : '' },
                    _react2.default.createElement(
                        'a',
                        { onClick: function onClick() {
                                return _this2.setPage(1);
                            } },
                        'First'
                    )
                ),
                pager.currentPage !== 1 && _react2.default.createElement(
                    'li',
                    { className: pager.currentPage === 1 ? 'disabled' : '' },
                    pager.currentPage !== 1 && _react2.default.createElement(
                        'a',
                        { onClick: function onClick() {
                                return _this2.setPage(pager.currentPage - 1);
                            } },
                        '\u2190'
                    ),
                    pager.currentPage === 1 && _react2.default.createElement(
                        'span',
                        { style: { padding: '0 13px', margin: '0 6px' } },
                        '\xA0'
                    )
                ),
                pager.pages.map(function (page, index) {
                    return _react2.default.createElement(
                        'li',
                        {
                            key: index,
                            className: pager.currentPage === page ? 'active' : ''
                        },
                        _react2.default.createElement(
                            'a',
                            { onClick: function onClick() {
                                    return _this2.setPage(page);
                                } },
                            page
                        )
                    );
                }),
                pager.currentPage !== pager.totalPages && _react2.default.createElement(
                    'li',
                    { className: pager.currentPage === pager.totalPages ? 'disabled' : '' },
                    pager.currentPage !== pager.totalPages && _react2.default.createElement(
                        'a',
                        { onClick: function onClick() {
                                return _this2.setPage(pager.currentPage + 1);
                            } },
                        '\u2192'
                    ),
                    pager.currentPage === pager.totalPages && _react2.default.createElement(
                        'span',
                        { style: { padding: '0 13px', margin: '0 6px' } },
                        '\xA0'
                    )
                ),
                _react2.default.createElement(
                    'li',
                    { className: pager.currentPage === pager.totalPages ? 'disabled' : '' },
                    _react2.default.createElement(
                        'a',
                        { onClick: function onClick() {
                                return _this2.setPage(pager.totalPages);
                            } },
                        'Last'
                    )
                )
            );
        }
    }]);

    return Pagination;
}(_react2.default.Component);

Pagination.propTypes = {
    /** The array of items to paginate */
    items: _propTypes2.default.array.isRequired,
    /** The function to call when clicking the pagination buttons to change page */
    onChangePage: _propTypes2.default.func.isRequired,
    /** The initial starting page */
    initialPage: _propTypes2.default.number,
    /** The number of items to show per page */
    pageSize: _propTypes2.default.number,
    /** The number of pages to show between next/prev */
    numPagesToShow: _propTypes2.default.oneOf([5, 10])
};

Pagination.defaultProps = {
    numPagesToShow: 5,
    initialPage: 1,
    pageSize: 10
};

exports.default = Pagination;