'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _StarIcon = require('../StarIcon');

var _StarIcon2 = _interopRequireDefault(_StarIcon);

require('./Rating.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/** Star Rating component that sets the selection on click and has hover animation */
var Rating = function (_React$Component) {
    _inherits(Rating, _React$Component);

    function Rating(props) {
        _classCallCheck(this, Rating);

        var _this = _possibleConstructorReturn(this, (Rating.__proto__ || Object.getPrototypeOf(Rating)).call(this, props));

        _this.onClick = function (rating) {
            if (_this.props.rating) {
                return;
            } // disable

            _this.setState({
                tempRating: rating,
                rating: rating
            });
        };

        _this.onMouseOver = function (rating) {
            if (_this.props.rating) {
                return;
            } // disable

            _this.setState({
                tempRating: _this.state.rating,
                rating: rating
            });
        };

        _this.onMouseOut = function () {
            if (_this.props.rating) {
                return;
            } // disable

            _this.setState({
                rating: _this.state.tempRating
            });
        };

        _this.render = function () {
            var fill = '#29292A';
            var stars = [];

            var _loop = function _loop(i) {
                var isHalf = _this.state.rating % 1 > 0;
                var fillType = 'transparent';

                if (_this.state.rating !== null) {
                    if (_this.state.rating >= i) {
                        fillType = 'full';
                    } else if (isHalf && Math.ceil(_this.state.rating) === i) {
                        fillType = 'half';
                    }
                }

                stars.push(_react2.default.createElement(
                    'a',
                    {
                        key: i,
                        className: 'star-link',
                        style: !_this.props.rating ? { cursor: 'pointer' } : {},
                        onClick: function onClick() {
                            return _this.onClick(i);
                        },
                        onMouseOver: function onMouseOver() {
                            return _this.onMouseOver(i);
                        },
                        onMouseOut: function onMouseOut() {
                            return _this.onMouseOut();
                        }
                    },
                    _react2.default.createElement(_StarIcon2.default, { fillType: fillType, fill: fill, size: _this.props.size })
                ));
            };

            for (var i = 1; i <= _this.props.scale; i++) {
                _loop(i);
            }

            return _react2.default.createElement(
                'div',
                { className: 'reviews-rating' },
                _react2.default.createElement(
                    'span',
                    { className: 'star-rating' },
                    stars
                ),
                _this.props.showAverage && _react2.default.createElement(
                    'span',
                    { className: 'star-average' },
                    _this.props.rating
                ),
                _this.props.totalRatings && _react2.default.createElement(
                    'span',
                    { className: 'star-total' },
                    _this.props.totalRatings,
                    ' reviews'
                )
            );
        };

        _this.state = {
            rating: _this.props.rating || null,
            tempRating: null
        };
        return _this;
    }

    return Rating;
}(_react2.default.Component);

Rating.propTypes = {
    /** Show the average rating value or not */
    showAverage: _propTypes2.default.bool,

    /** The total number of reviews that have included a rating */
    totalRatings: _propTypes2.default.number,

    /** The size of the stars in the rating component */
    size: _propTypes2.default.number,

    /** The rating scale number for how many stars */
    scale: _propTypes2.default.number,

    /** The rating value to set initially if needed */
    rating: _propTypes2.default.number
};

Rating.defaultProps = {
    totalRatings: null,
    rating: null,
    size: 32,
    scale: 5
};

exports.default = Rating;