'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/** Star Icon component for the atom of a star rating component */

var StarIcon = function StarIcon(_ref) {
    var fillType = _ref.fillType,
        fill = _ref.fill,
        stroke = _ref.stroke,
        size = _ref.size;

    return _react2.default.createElement(
        'svg',
        {
            id: 'star-icon',
            className: 'star-icon',
            xmlns: 'http://www.w3.org/2000/svg',
            width: size,
            height: size,
            viewBox: '0 0 32 32'
        },
        _react2.default.createElement('path', {
            className: 'full',
            d: 'M15.25,22.08l-8,4.24,1.53-9L2.25,11l9-.12,4-9.36,4,9.36,9,.12-6.5,6.36,1.53,9Z',
            transform: 'translate(-1.04 -0.23)',
            fill: fillType === 'full' ? fill : 'transparent',
            stroke: stroke
        }),
        _react2.default.createElement('path', {
            className: 'half',
            d: 'M15.25,22.08l-8,4.24,1.53-9L2.25,11l9-.12,4-9.36Z',
            transform: 'translate(-1.04 -0.23)',
            fill: fillType === 'half' ? fill : 'transparent',
            stroke: 'transparent'
        })
    );
};

StarIcon.propTypes = {
    /** The size of the star */
    size: _propTypes2.default.number,

    /** The stroke color for the border of each star */
    stroke: _propTypes2.default.string,

    /** The fill color */
    fill: _propTypes2.default.string,

    /** The fill type - blank for empty or half or full  */
    fillType: _propTypes2.default.string
};

StarIcon.defaultProps = {
    size: 32,
    stroke: '#29292A',
    fill: 'transparent',
    fillType: null
};

exports.default = StarIcon;