'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _QuestionMark = require('../QuestionMark/QuestionMark');

var _QuestionMark2 = _interopRequireDefault(_QuestionMark);

require('./Tooltip.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/** Tooltip component that takes a label for the text to tooltip and children for the content of the tooltip itself. */
var Tooltip = function (_React$Component) {
    _inherits(Tooltip, _React$Component);

    function Tooltip(props) {
        _classCallCheck(this, Tooltip);

        var _this = _possibleConstructorReturn(this, (Tooltip.__proto__ || Object.getPrototypeOf(Tooltip)).call(this, props));

        _this.onMouseOver = function () {
            _this.setState({
                isVisible: true
            });
        };

        _this.onMouseOut = function () {
            _this.setState({
                isVisible: false
            });
        };

        _this.state = {
            isVisible: false
        };
        return _this;
    }

    _createClass(Tooltip, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            document.addEventListener('mousedown', this.onMouseOut);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            document.removeEventListener('mousedown', this.onMouseOut);
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var isVisible = this.state.isVisible ? 'is-visible' : 'is-hidden';
            var className = 'tooltip ' + isVisible;
            var _props = this.props,
                label = _props.label,
                click = _props.click;


            if (click) {
                return _react2.default.createElement(
                    'div',
                    {
                        className: className,
                        onClick: function onClick() {
                            return _this2.onMouseOver();
                        }
                    },
                    _react2.default.createElement(
                        'div',
                        { className: 'tooltip-label' },
                        label,
                        _react2.default.createElement(_QuestionMark2.default, null)
                    ),
                    _react2.default.createElement(
                        'div',
                        { className: 'tooltip-content' },
                        this.props.children
                    )
                );
            }

            return _react2.default.createElement(
                'div',
                {
                    className: className,
                    onMouseEnter: function onMouseEnter() {
                        return _this2.onMouseOver();
                    },
                    onMouseOut: function onMouseOut() {
                        return _this2.onMouseOut();
                    }
                },
                _react2.default.createElement(
                    'div',
                    { className: 'tooltip-label' },
                    label,
                    _react2.default.createElement(_QuestionMark2.default, null)
                ),
                _react2.default.createElement(
                    'div',
                    { className: 'tooltip-content' },
                    this.props.children
                )
            );
        }
    }]);

    return Tooltip;
}(_react2.default.Component);

Tooltip.defaultProps = {
    click: false
};

Tooltip.propTypes = {
    /** The text to show for the tooltip that you hover */
    label: _propTypes2.default.string.isRequired,

    /** If the tooltip should be activated on click this is true */
    click: _propTypes2.default.bool
};

exports.default = Tooltip;